----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2017/--/-- --:--:--
-- Design Name: 
-- Module Name: UpDown_Counter - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.all;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity UpDown_Counter is
    port ( CLK	 : in  STD_LOGIC;
           RESET : in  STD_LOGIC;
           BTN	 : in  STD_LOGIC_VECTOR (1 downto 0);
           Q	 : out STD_LOGIC_VECTOR (3 downto 0));
end UpDown_Counter;

architecture Behavioral of UpDown_Counter is
    signal temp_count : STD_LOGIC_VECTOR (15 downto 0);
    signal temp_q     : STD_LOGIC_VECTOR (3 downto 0);
    signal edge, buff : STD_LOGIC_VECTOR (1 downto 0);
    signal inc, dec   : STD_LOGIC;
begin
    process (CLK, RESET)
    begin
        if (RESET = '1') then
            temp_count <= (others => '0');
        elsif (CLK' event and CLK = '1') then
            temp_count <= temp_count + '1';
        end if;
    end process;

    process (CLK)
    begin
        if (CLK' event and CLK = '1') then
            if (temp_count = 0) then
                edge <= BTN;
            end if;
        end if;
    end process;
    
    process (CLK, RESET)
    begin
        if (RESET = '1') then
            buff <= (others => '0');
        elsif (CLK' event and CLK = '1') then
            buff <= edge;
        end if;
    end process;
    
    inc <= edge(0) and not buff(0);
    dec <= edge(1) and not buff(1);
    
    process (CLK, RESET)
    begin
        if (RESET = '1') then
            temp_q <= (others => '0');
        elsif (CLK' event and CLK = '1') then
            if (inc = '1') then
                if (temp_q = 15) then
                    temp_q <= (others => '0');
                else
                    temp_q <= temp_q + '1';
                end if;
            elsif (dec = '1') then
                if (temp_q = 0) then
                    temp_q <= "1001";
                else
                    temp_q <= temp_q - '1';
                end if;
            end if;                
        end if;
    end process;
    
    Q <= temp_q;
end Behavioral;