----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2017/--/-- --:--:--
-- Design Name: 
-- Module Name: Counter_7seg - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.all;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Counter_7seg is
    port ( CLK		: in  STD_LOGIC;
           RESET	: in  STD_LOGIC;
           BTN		: in  STD_LOGIC_VECTOR (1 downto 0);
           SEG		: out STD_LOGIC_VECTOR (11 downto 0));
end Counter_7seg;

architecture Behavioral of Counter_7seg is
    signal temp_count : STD_LOGIC_VECTOR (15 downto 0);
    signal temp_q     : STD_LOGIC_VECTOR (3 downto 0);
    signal edge, buff : STD_LOGIC_VECTOR (1 downto 0);
    signal inc, dec   : STD_LOGIC;
begin
    process (CLK, RESET)
    begin
        if (RESET = '1') then
            temp_count <= (others => '0');
        elsif (CLK' event and CLK = '1') then
            temp_count <= temp_count + 1;
        end if;
    end process;

    process (CLK)
    begin
        if (CLK' event and CLK = '1') then
            if (temp_count = 0) then
                edge <= BTN;
            end if;
        end if;
    end process;
    
    process (CLK, RESET)
    begin
        if (RESET = '1') then
            buff <= (others => '0');
        elsif (CLK' event and CLK = '1') then
            buff <= edge;
        end if;
    end process;
    
    inc <= edge(0) and not buff(0);
    dec <= edge(1) and not buff(1);
    
    process (CLK, RESET)
    begin
        if (RESET = '1') then
            temp_q <= (others => '0');
        elsif (CLK' event and CLK = '1') then
            if (inc = '1') then
                if (temp_q = 9) then
                    temp_q <= (others => '0');
                else
                    temp_q <= temp_q + 1;
                end if;
            elsif (dec = '1') then
                if (temp_q = 0) then
                    temp_q <= "1001";
                else
                    temp_q <= temp_q - 1;
                end if;
            end if;                
        end if;
    end process;

    process (temp_q)
    begin
        case temp_q is
				when "0000" => SEG <= "111011000000";--0
            when "0001" => SEG <= "111011111001"; --1
            when "0010" => SEG <= "111010100100"; --2
            when "0011" => SEG <= "111010110000"; --3
            when "0100" => SEG <= "111010011001"; --4
            when "0101" => SEG <= "111010010010"; --5
            when "0110" => SEG <= "111010000010"; --6
            when "0111" => SEG <= "111011011000"; --7
            when "1000" => SEG <= "111010000000"; --8
            when "1001" => SEG <= "111010010000"; --9
            when others => SEG <= "111111111111"; --
        end case;
    end process;
end Behavioral;

