`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2017/--/-- --:--:--
// Design Name: 
// Module Name: Btn_Counter
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module Btn_Counter(
    input CLK,
    input RESET,
    input BTN,
    output [3:0] Q
    );
	
	wire inc;
	reg [3:0] ff = 0;
	reg [19:0] temp_count = 0;
	reg out, buff;
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			temp_count <= 0;
		else
			temp_count <= temp_count + 1;
	end
	
	always @(posedge CLK)
		if (temp_count == 0)
			out <= BTN;
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			buff <= 0;
		else
			buff <= out;
	end
	
	assign inc = out & ~buff;
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			ff <= 0;
		else if (inc == 1)
			if (ff == 9)
				ff <= 0;
			else
				ff <= ff + 1;
	end

	assign Q = ff;

endmodule
