`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2017/--/-- --:--:--
// Design Name: 
// Module Name: Updown_Counter
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module Updown_Counter(
    input CLK,
    input RESET,
    input [1:0] BTN,
    output [3:0] Q
    );

	wire inc, dec;
	reg [3:0] ff = 0;
	reg [19:0] temp_count = 0;
	reg [1:0] out, buff;
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			temp_count <= 0;
		else
			temp_count <= temp_count + 1;
	end
	
	always @(posedge CLK)
		if (temp_count == 0)
			out <= BTN;
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			buff <= 0;
		else
			buff <= out;
	end
	
	assign inc = out[0] & ~buff[0];
	assign dec = out[1] & ~buff[1];
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			ff <= 0;
		else if (inc == 1)
			if (ff == 15)
				ff <= 0;
			else
				ff <= ff + 1;
		else if (dec == 1)
			if (ff == 0)
				ff <= 15;
			else
				ff <= ff -1;
	end

	assign Q = ff;
endmodule
